<?php
    require_once(dirname(dirname(dirname(dirname(__FILE__))))."/engine/engine.php");

    $assessment_id = get_input('assessment_id');
    $course_id = get_input('course');
    $obj_id = 0;
    $handler = get_input('handler', 'assessments');
    $type = "assessment";
    
    $forward_to = WWW_ROOT . "{$handler}/{$type}/{$assessment_id}/view";
    if ($TeKe->plugin->is_test_constructor()) {
        $forward_to = WWW_ROOT . "{$handler}/{$type}/{$assessment_id}/candidates";
    }

    $course = get_course_by_id($course_id);
    $learners = $course->listLearnersFull();

    $assessment = $TeKe->plugin->loadType("assessment", $assessment_id);
    
    // send assessment to bos
    $assignment = new Assignment();
    $assignment->title = $assessment->getTitle();
    $assignment->course = $course_id;
    $assignment->subtype = "test";
    $assignment->start = strtotime($assessment->getBeginning());
    $assignment->deadline = strtotime($assessment->getEnding());
    $assignment->description = $assessment->getDescription();
    $assignment->maxpoints = $assessment->getMaximumScore();
    $assignment_id = $assignment->create();

    $assessment->saveCourse($assignment_id, $course_id, $course->title);

    foreach ($learners as $learner) {
        $first_name = $learner->firstname;
        $last_name = $learner->lastname;
        $email = $learner->email;
        $candidate_data = array(
            "assessment_id" => $assessment_id,
            "first_name" => $first_name,
            "last_name" => $last_name,
            "email" => $email    
        );
        $candidate = $TeKe->plugin->loadType("candidate", 0);
        $obj_id = $candidate->build($candidate_data);
        if (!$obj_id) {
        }

        // create answer to bos
        $answer = new Answer();
        $answer->assignment = $assignment_id;
        $answer->url = $candidate->getAssessmentURL();
        $answer->creator = $learner->id;
        $answer_id = $answer->create();
        $candidate->saveAnswer($answer_id);
        $candidate->saveLearner($learner->id);

    } 

    $TeKe->add_system_message(_("Saved"));
    forward($forward_to);

?>

