<?php

class Exporter {
    
    function __construct() {
    }
    
    function export($ids) {
        global $TeKe;
        $zip = new ZipArchive;
        $filename = tempnam(sys_get_temp_dir(), "items");
        $res = $zip->open($filename, ZipArchive::CREATE);
        if ($res === true) {
            foreach ($ids as $id) {
                $item = $TeKe->plugin->loadType("", $id);
                $itemXML = $item->getXML();
                $zip->addFromString("{$id}.xml", $itemXML);
            }
            $manifest = $this->createManifestFile($ids);
            $zip->addFromString("imsmanifest.xml", $manifest);
            $zip->close();
        }
        return $filename;
    }

    function createManifestFile($ids) {
        global $TeKe;
        $manifest = $this->manifest_beginning();
        foreach ($ids as $id) {
            $item = $TeKe->plugin->loadType("", $id);
            $item_package = $item->getPackage();
            $manifest .= $item_package;
        }
        $manifest .= $this->manifest_end();
        return $manifest;
    }

    function manifest_beginning() {
        $pack = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<manifest identifier=\"MANIFEST-".mt_rand()."\" xmlns=\"http://www.imsglobal.org/xsd/imscp_v1p1\" xmlns:imsmd=\"http://www.imsglobal.org/xsd/imsmd_v1p2\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:imsqti=\"http://www.imsglobal.org/xsd/imsqti_v2p1\" xsi:schemaLocation=\"http://www.imsglobal.org/xsd/imscp_v1p1 imscp_v1p1.xsd http://www.imsglobal.org/xsd/imsmd_v1p2 imsmd_v1p2p2.xsd http://www.imsglobal.org/xsd/imsqti_v2p1 imsqti_v2p1.xsd\">
    <metadata>
        <schema>IMS Content</schema>
        <schemaversion>1.1</schemaversion>
        <imsmd:lom>
            <imsmd:general>
                <imsmd:title>
                    <imsmd:langstring xml:lang=\"en\">Contentpackage with QTI v2.1 items</imsmd:langstring>
                </imsmd:title>
                <imsmd:language>en</imsmd:language>
                <imsmd:description>
                    <imsmd:langstring xml:lang=\"en\">Contentpackage</imsmd:langstring>
                </imsmd:description>
            </imsmd:general>
            <imsmd:metametadata>
                <imsmd:metadatascheme>LOMv1.0</imsmd:metadatascheme>
                <imsmd:metadatascheme>QTIv2.1</imsmd:metadatascheme>
                <imsmd:language>en</imsmd:language>
            </imsmd:metametadata>
            <imsmd:rights>
                <imsmd:description>
                    <imsmd:langstring xml:lang=\"en\">
                        (c) 2004, IMS Global Learning Consortium; individual questions may have own copyright statement.
                    </imsmd:langstring>
                </imsmd:description>
            </imsmd:rights>
        </imsmd:lom>
    </metadata>
    <organizations/>
    <resources>\n";
        return $pack;
   }

    function manifest_end() {
        return "\t</resources>\n</manifest>";
    }
}
?>
