# Grab translatable strings from sources
# merge them into psyhvel-php.pot
# Note: this requires Python (2.6 or later) + i18ndude installed in the system
# If you already have python in the system just run: sudo easy_install i18ndude
# Note: in order to use easy_install python needs setuptools to be present
# More information can be found here: http://pypi.python.org/pypi/setuptools 

# Output initial number of translation strings if available
if [ -f tester.pot ]
then
	echo "Translations in tester.pot:" $(( $(cat tester.pot|grep 'msgid'|wc -l) - 1 ))
fi

#Note: all .php files in the project are scanned for translation strings
find .. -iname "*.php" | xargs xgettext --default-domain=tester --language=PHP --output=php.pot
if [ -r php.pot ]
then
	echo "Standard .php files processed ok:" $(( $(cat php.pot|grep 'msgid'|wc -l) - 1 ))
else
	echo "Problem processing standard .php files!" && exit 1
fi

#Write pickup for templates.pot
i18ndude rebuild-pot --pot templates.pot --create tester ../views/ ../views/tests/
if [ -r templates.pot ]
then
	echo "Templates processed ok:" $(( $(cat templates.pot|grep 'msgid'|wc -l) - 1 ))
else
	echo "Problem processing templates!" && exit 1
fi

echo "Translations is manual.pot:" $(( $(cat manual.pot|grep 'msgid'|wc -l) - 1 ))
#Merge all pots into main tester.pot
msgcat --use-first --to-code=UTF-8 php.pot templates.pot manual.pot tester.pot > tester.pot

#Filter out unneded translation strings
echo "Translations in ignored.pot:" $(( $(cat ignored.pot|grep 'msgid'|wc -l) - 1 ))
i18ndude filter tester.pot ignored.pot > filtered.pot
mv filtered.pot tester.pot

# Remove unneeded .pot files
if [ -f php.pot ]
then
	rm php.pot
fi
if [ -f templates.pot ]
then
	rm templates.pot
fi

# Output final number of translations
echo "Translations in tester.pot:" $(( $(cat tester.pot|grep 'msgid'|wc -l) - 1 ))

# Merge the new strings from psyhvel.pot into locale-specific .po files
# ENG
msgmerge ../../../i18n/en_GB.UTF-8/LC_MESSAGES/tester.po tester.pot > new.po
mv new.po ../../../i18n/en_GB.UTF-8/LC_MESSAGES/tester.po
# EST
msgmerge ../../../i18n/et_EE.UTF-8/LC_MESSAGES/tester.po tester.pot > new.po
mv new.po ../../../i18n/et_EE.UTF-8/LC_MESSAGES/tester.po
# RUS
#msgmerge ../../../i18n/ru_RU.UTF-8/LC_MESSAGES/tester.po tester.pot > new.po
#mv new.po ../../../i18n/ru_RU.UTF-8/LC_MESSAGES/tester.po

echo "Done"
