    $(function() {
        $("#category_add").click(function() {
            $("#categories_tree").jstree("create");
            
        });
        $("#category_rename").click(function() {
            $("#categories_tree").jstree("rename");
            
        });
        $("#category_unselect").click(function() {
            $("#categories_tree").jstree("deselect_all");
            $("#category").val("");
        });
        $("#category_delete").click(function() {
            if (confirmDelete()) {
                $("#categories_tree").jstree("remove");
            }
        });
        $("#categories_tree").jstree({
            "json_data" : {
                "ajax" : {
                "url" : PLUGIN_ROOT + "actions/category_actions.php",
                    "data" : function (n) {
                        return {
                            "operation" : "get_children",
                            "id" : n.attr ? n.children("a").attr("id") : 0
                        };
                    },
                    "dataType" : "json",
                    "type": "GET"
                },
            },
            "ui" : {
                "select_limit" : 1,
                "initially_select" : [ $("#category").val() ]
                //"select_multiple_modifier" : "alt"
            },
            "themes" : {
                "theme" : "apple",
                "icons" : false
            },
            "plugins": ["themes", "ui", "crrm", "json_data"]           
        });
        $("#categories_tree").bind("select_node.jstree", function(event, data) {
            var id = 0;
            if (data.rslt.obj.attr("id")) {
                id = data.rslt.obj.attr("id");
            } else {
                id = data.rslt.obj.children("a").attr("id");
            }
            $("#category").val(id);
        });
        $("#categories_tree").bind("create.jstree", function(e, data) {
            var parent_id = 0;
            if (data.rslt.parent.attr) {
                if (data.rslt.parent.attr("id")) {
                    parent_id = data.rslt.parent.attr("id");
                } else {
                    parent_id = data.rslt.parent.children("a").attr("id");
                }
            }
            $.post(
                 PLUGIN_ROOT + "actions/category_actions.php",
                 {
                 "operation" : "create",
                 "parent_id" : parent_id,
                 "position" : data.rslt.position,
                 "title" : data.rslt.name,
                 "type" : data.rslt.obj.attr("rel")
                 },
                 function (result) {
                    if (result.status == "success") {
                        $(data.rslt.obj).children("a").attr("id", result.id);
                    } else {
                        $.jstree.rollback(data.rlbk);
                    }
                 },
                 "json"
             );
        });
        $("#categories_tree").bind("rename.jstree", function(e) {
            alert("rename");
        });
        $("#categories_tree").bind("remove.jstree", function(e, data) {
            $.ajax({
                url : PLUGIN_ROOT + "actions/category_actions.php",
                data : {
                    "operation" : "remove",
                    "id" : data.rslt.obj.children("a").attr("id"),
                    "position" : data.rslt.position,
                    "title" : data.rslt.name,
                    "type" : data.rslt.obj.attr("rel")
                },
                success : function(result) {
                    if (result.status == "success") {
                        $("#categories_tree").jstree("deselect_all");
                        $("#category").val("");
                    } else {
                        $.jstree.rollback(data.rlbk);
                    }
                 },
                dataType : "json",
                error : function(result) {
                    $.jstree.rollback(data.rlbk);
                }
            });
        });
    });

